# =====================================================================
# AWK functions for CSA.
#
# Copyright (c) 2001,2006 Carlo Strozzi
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; version 2 dated June, 1991.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License 
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#
# =====================================================================
# boolean _isuri(string uri)
#
# Return _TRUE if the received string is a sintactically valid URI, or
# _FALSE otherwise.
# =====================================================================

function _isuri(uri) {

  # This pattern matches URI in a very broad manner, but on the other
  # hand it is rather difficult to be more selective. Furthermore, it
  # does not currently check whether the received string contains
  # invalid URI characters, beside SPACE, '\t', '\r', and '\n'.

  if (uri ~ /^[a-z][a-z0-9]+:[^ \t\r\n]+$/) return _TRUE
  else return _FALSE
}
